#include <qmultilineedit.h>
#include <qtextstream.h>
#include <qmessagebox.h>

#include <stdlib.h>
#include <string.h>

#include "my_editor.h"

MyEditor::MyEditor(QWidget *parent, char *name) : QMultiLineEdit(parent, name)
{
  fps_value = 25.0;
  timeformat = 1;
}


 // konwersja formatu // konwersja formatu // konwersja formatu // konwersja formatu
QString MyEditor::convertFunction(QString linia, QString linianext)
{
  double showtime, hidetime;
  int format;
  char line[512];
  strcpy(line, linia.ascii());
  char text[512];
  if (getline(line, format, showtime, hidetime, text))
  {
    putline(convertDestFormat, showtime, hidetime, text, line);
    linia = line;
  }
  return linia;
}

 // przesuniecie czasu wyswietlenia napisow // przesuniecie czasu wyswietlenia napisow
QString MyEditor::shiftTimeFunction(QString linia, QString linianext)
{
  double showtime, hidetime;
  int format;
  char line[512];
  strcpy(line, linia.ascii());
  char text[512];
  if (getline(line, format, showtime, hidetime, text))
  {
    if (shiftTimeShowTimeChange)
      showtime += shiftTimeValue;
    if (shiftTimeHideTimeChange)
      hidetime += shiftTimeValue;
    putline(format, showtime, hidetime, text, line);
    linia = line;
  }
  return linia;
}

 // przesuniecie czasu wyswietlenia napisow // przesuniecie czasu wyswietlenia napisow
QString MyEditor::showTimeChangeFunction(QString linia, QString linianext)
{
  double showtime, hidetime;
  int format;
  char line[512], linenext[512];
  strcpy(line, linia.ascii());
  strcpy(linenext, linianext.ascii());
  char text[512];
  bool line_ok;

  if (getline(line, format, showtime, hidetime, text))
  {
    if (showTimeChangeEnterEmpty)
    {
      hidetime = 0;
      putline(format, showtime, hidetime, text, line);
    }
    else
    {
      if ( ( showTimeChangeOnlyEmpty && (hidetime==0) ) || (!showTimeChangeOnlyEmpty) )
      {
        double hidetmp = hidetime;
	hidetime = showtime+showTimeChangeTime;
        if ( showTimeChangeDependentOnLen ) hidetime = showtime + getSubtitlesTime(text, showTimeChangeTime);
	if ( showTimeChangeBlock ) 
	{
	  double st2, ht2;
	  int format2;
	  char text2[512];
	  if (getline(linenext, format2, st2, ht2, text2))
	    if ( (hidetime>st2) && (st2>0.0) ) hidetime = st2;
	}
        putline(format, showtime, hidetime, text, line);
      }
    }
    linia = line;
  }
  return linia;
}


 // zmiana FPS // zmiana FPS // zmiana FPS // zmiana FPS // zmiana FPS // zmiana FPS
QString MyEditor::fpsChangeFunction(QString linia, QString linianext)
{
  double showtime, hidetime;
  int format;
  char line[512];
  strcpy(line, linia.ascii());
  char text[512];
  double tempfps = fps_value;
  
  fps_value = fpsChangeSource;
  if (getline(line, format, showtime, hidetime, text))
  {
    fps_value = fpsChangeDest;
    putline(format, showtime, hidetime, text, line);
    linia = line;
  }
  fps_value = tempfps;
  return linia;
}

 // popraw napisy // popraw napisy // popraw napisy // popraw napisy // popraw napisy //

  //////  funkcje do poprawiania napisow //////
  char *cutspacesright (char *linia, int poz=0) // usuwa wszystkie poczatkowe spacje
  {
    int spccount=0;
    for (int i=poz; i<(signed int) (strlen(linia)); i++)
      if ( linia[i] == ' ') spccount++;
      else break;
    for (int i=poz; i<(signed int) (strlen(linia)-spccount+1); i++)
      linia[i]=linia[i+spccount];
    return linia;
  }
  char *cutspacesleft (char *linia, int poz) // usuwa wszystkie spacje w lewo
  {
    int spccount=0;
    for (int i=poz; i>0; i--)
      if ( linia[i] == ' ') spccount++;
      else break;
    for (int i=poz-spccount+1; i<(signed int)(strlen(linia)-spccount+1); i++)
      linia[i]=linia[i+spccount];
    return linia;
  }
  void delendspc (char *linia) // usuwa wszystkie koncowe spacje z linii
  {
    int strlength = strlen(linia);
    if (linia[strlength-1]==' ')
    {
      linia[strlength-1]='\0';
      delendspc (linia);
    }
  }
  bool numaround(char *linia, int i) // zwraca true jezeli dookola 'i' sa cyfry
  {
    if ( (linia[i-1]>='0')&&(linia[i-1]<='9')
         &&(linia[i+1]>='0')&&(linia[i+1]<='9') )
      return true;
    else
      return false;
  }
  int cutcolor (char *linia) // obcina tekst z informacji o kolorze
  {
    int max = strlen (linia);
    int _od=0, _do;
    while (linia[_od++]!='{') // znajduje pierwsze otwarcie nawiasu
      if (max<_od) return 0;
    _do=_od;
    while (linia[_do++]!='}') // znajduje pierwsze zamkniecie nawiasu
      if (max<_do) return 0;
    for (int i=_od; i<_od+max-_do+1; i++) // przyciecie wybranego kawalka
      linia[i-1] = linia[i+_do-_od];
    cutcolor(linia);
    return 1;
  }
  bool charintab (char znak, char *tab, int tabsize) // jezeli ZNAK jest w TAB zwraca true
  {
    for (int i=0; i<tabsize; i++)
      if (tab[i]==znak) return true;
    return false;
  }
QString MyEditor::correctFunction(QString linia, QString linianext)
{
  double showtime, hidetime;
  int format;
  char line[512], text[512], txt[512];
  strcpy(line, linia.ascii());
  if (getline(line, format, showtime, hidetime, text))
  {
    //1.1//////////////// ustawa znaki interpunkcyjne ////////////////////
    if (correctPlacePunctuation)
    {
      char znaki[]= {'.',',','!','?',':',';'};
      int znakicount = 6;
      for (int j=0; j<(signed) strlen(text); j++)
      {
        if ( charintab(text[j], znaki, znakicount) ) // znaleziony znak interpunkcyjny
        {
          cutspacesright(text, j+1);
          int a = strlen(text);
          cutspacesleft(text, j-1);
          int len = strlen(text);
          j = j+len-a;
          if ( (text[j+1]!='|') && // nie wstawia spacji przed znak podzialu wiersza
               (!charintab(text[j+1], znaki, znakicount)) && // nie wstawia spacji jezeli nastepny znak jest znakiem interpunkcyjnym
               (j+1<len) && // nie wstaiwia spacji jezeli jest koniec linii
               !( text[j]=='.'
                  && (text[j-1]>=48 && text[j-1]<=57)
                  && (text[j+1]>=48 && text[j+1]<=57)) // nie wstawia spacji jezeli '.' jest miedzy cyframi
               &&
               !( text[j]==':'
                  && (text[j-1]>=48 && text[j-1]<=57)
                  && (text[j+1]>=48 && text[j+1]<=57)) // nie wstawia spacji jezeli ':' jest miedzy cyframi
             )
          {
            for (int i=len; i>j; i--) // wstawia spacje za znak
              text[i]=text[i-1];
            text[len+1]='\0';
            text[j+1]=' ';
          }
        }
      }
    }
    //1.1//////////////// ustawia znak myslnika ////////////////////
    if (
correctDashArrabgement)
    {
      char znaki[]= {'-'};
      int znakicount = 1;
      bool poczatek = true; // poczatek wiersza (ewent. spacje)
      for (int j=0; j<(signed) strlen(text); j++)
      {
        if (text[j]=='|') {poczatek=true; continue;}

        if (poczatek && !( text[j]!=' ' || charintab(text[j], znaki, znakicount) ) )
          poczatek=false;

        if ( poczatek && charintab(text[j], znaki, znakicount) ) // znaleziony znak interpunkcyjny
        {
          cutspacesright(text, j+1);
          int a = strlen(text);
          cutspacesleft(text, j-1);
          int len = strlen(text);
          j = j+len-a;
          if ( (text[j+1]!='|') &&
               (!charintab(text[j+1], znaki, znakicount)) &&
               (j+1<len)  )
          {
            for (int i=len; i>j; i--) // wstawia spacje za znak
              text[i]=text[i-1];
            text[len+1]='\0';
            text[j+1]=' ';
          }
          poczatek=false;
        }
      }
    }
    //2////////////////// usuwa wielokrotne spacje ////////////////////
    if (correctDelDblSpaces)
    {
      cutspacesright(text);
      for (int j=0; j<(signed) strlen(text); j++)
        if (text[j]==' ') cutspacesright(text+j+1);
    }
    //3////////////////// usuwa spacje na koncu wierszy ////////////////////
    if (correctDelEolSpaces)
    {
      delendspc(text);
      for (int j=0; j<(signed) strlen(text); j++)
        if (text[j]=='|') cutspacesright(text+j+1);
      for (int j=0; j<(signed) strlen(text); j++)
        if (text[j]=='|') cutspacesleft(text, j-1);
    }
    //4////////////////// usuwa spacje miedzy cyframi ////////////////////
    if (correctDelNumSpaces)
    {
      int ii=1;
      while (text[ii+1]!='\0')
      {
        if (text[ii]==' ')
          if (numaround(text, ii))
          {
            int j=ii;
            while (text[j]!='\0')
            {
              text [j]= text[j+1];
              j++;
            }
          }
        ii++;
      }
    }
    //5////////////////// obcina informacje o kolorze ////////////////////
    if (correctCutColors
)
    {
      cutcolor(text);
    }
    //6////////////////// blokuje czas koncowy  ////////////////////
    if (correctBlockShowTime)
    {
      char linenext[512];
      strcpy(linenext, linianext.ascii());
      double st2, ht2;
      int format2;
      char text2[512];
      if (getline(linenext, format2, st2, ht2, text2))
        if ( (hidetime>st2) && (st2>0.0) ) hidetime = st2;
    }
    //////////////////////////////////////////////////////////////////////

    putline(format, showtime, hidetime, text, line);
    linia = line;
  }
  return linia;
}


 // ogolna funkcja do zmian napisow // ogolna funkcja do zmian napisow // ogolna funkcja do zmian napisow //

bool MyEditor::linesChange(int change)
{
  int caretline, caretcol;
  this->getCursorPosition(&caretline, &caretcol);
  QString mytext = this->text();
  this->clear();
  bool koniec = false;
  QTextStream strum(mytext, IO_ReadOnly);
  
  QString linia, linianext;
  linia = strum.readLine(); 
  while(!koniec)
  {
    if (strum.eof()) koniec = true;
    if (!strum.eof())
      linianext = strum.readLine();
    else
      linianext = "";
    
    switch(change)
    {
      case 1: // convert
        this->append(convertFunction(linia, linianext));
        break;
      case 2: // shift time
        this->append(shiftTimeFunction(linia, linianext));
	break;
      case 3: // show time
        this->append(showTimeChangeFunction(linia, linianext));
	break;
      case 4: // FPS change
        this->append(fpsChangeFunction(linia, linianext));
	break;
      case 5: // correct subtitles text
        this->append(correctFunction(linia, linianext));
	break;
      default:
        qDebug("ERROR: undefined modification called!");
    }
    linia = linianext;
  }
  this->setCursorPosition(caretline, caretcol);
  this->setEdited(true);
}


MyEditor::~MyEditor()
{

}
