#include <qmultilineedit.h>
#include <qtextstream.h>


#ifndef MY_EDITOR_H
#define MY_EDITOR_H

#include <stdlib.h>
#include <string.h>

class MyEditor : public QMultiLineEdit
{
  Q_OBJECT
  public:
    double fps_value; // wartosc FPS napisow (filmu, dla ktorego sa napisy)
    MyEditor(QWidget *parent, char *name);
    ~MyEditor();

    bool linesChange(int);

  // CONVERT SUBTITLES
  int     convertDestFormat;
  QString convertFunction(QString, QString);
 
  // SHIFT TIME CHANGE
  double  shiftTimeValue; // przesuniecie
  bool    shiftTimeShowTimeChange; // zmieniaj klatki poczatkowe
  bool    shiftTimeHideTimeChange; // zmieniaj klatki koncowe
  QString shiftTimeFunction(QString, QString);

  // SHOW TIME CHANGE
  double  showTimeChangeTime;           // czas wyswietlania napisu
  bool    showTimeChangeEnterEmpty;     // wpisz puste pozycje
  bool    showTimeChangeOnlyEmpty;      // zmieniaj tylko nieokreslone indexy (czyli: {xxx}{} )
  bool    showTimeChangeDependentOnLen; // zalezny od dlugosci napisu
  bool    showTimeChangeBlock;          // blokada czasu pokazywania
  QString showTimeChangeFunction(QString, QString);
  
  // CHANGE FPS
  double  fpsChangeSource;   // wartosc FPS dla aktualnych napisow
  double  fpsChangeDest;     // nowa wartosc FPS
  QString fpsChangeFunction(QString, QString);
  
  // CORRECT SUBTITLES
  bool    correctDelDblSpaces;        // usuwa podwojne spacje
  bool    correctDelEolSpaces;        // usuwa spacje na koncach wierszy
  bool    correctDelNumSpaces;        // usuwa spacje miedzy cyframi
  bool    correctCutColors;           // usuwa informacje o kolorze
  bool    correctBlockShowTime;       // blokuje czas pokazywania napisu
  bool    correctPlacePunctuation;    // ustawia znaki interpunkcyjne
  bool    correctDashArrabgement;     // ustawia znak dialogow (-)
  QString correctFunction(QString, QString);

  private:

   #include "./subtitles_fun.h"

};

#endif
