#include <qwidget.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qlabel.h>

#include <stdlib.h>

#include "my_fps.h"

MyFps::MyFps(QWidget *parent, double *fpsvalue, bool cancel_enabled) : QDialog(parent, "my_fps", true)
{
  fps = fpsvalue;

  QPushButton *btn_ok, *btn_cancel;
  btn_ok     = new QPushButton("OK", this);
  btn_cancel = new QPushButton("Anuluj", this);
  btn_cancel ->setEnabled(cancel_enabled);
  btn_ok    ->setGeometry(40 , 90, 80, 20);
  btn_ok    ->setDefault(true);
  btn_cancel->setGeometry(130, 90, 80, 20);
  connect(btn_ok    , SIGNAL(clicked()), SLOT(accept()));
  connect(btn_cancel, SIGNAL(clicked()), SLOT(reject()));

  QWidget *w1  = new QWidget (this);
  w1->setGeometry(10, 20, 230, 15);
  QLabel  *l1  = new QLabel  ("Warto wspczynnika FPS napisw:", w1);
  l1->setAutoResize(true);

//  this->resize(300, 300);
//  this->show();

  edit = new QLineEdit(this);
  edit->setValidator( new QDoubleValidator(0.1, 200.0, 5, edit) );
  edit->setGeometry(20, 50, 210, 20); // 250
  char buf[10];
  edit->setText(gcvt(*fps, 10, buf));

  edit->setFocus();
};

MyFps::~MyFps()
{
  delete edit;
}


//////////////////// SLOTY /////////////////
void MyFps::accept()
{
  *fps = atof(edit->text());
  done(true);
}
