#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qvalidator.h>

#include <stdlib.h>

#include "sub_fpschange.h"

SubFpschange::SubFpschange(double *src, double *dest) : QDialog(NULL, "sub_shift", true)
{
  srcfps   = src;
  destfps  = dest;

  QPushButton *btn_ok, *btn_cancel;
  btn_ok     = new QPushButton("OK", this);
  btn_cancel = new QPushButton("Anuluj", this);
  btn_ok    ->setGeometry(40 +10, 140, 80, 20);
  btn_ok    ->setDefault(true);
  btn_cancel->setGeometry(130+10, 140, 80, 20);
  connect(btn_ok    , SIGNAL(clicked()), SLOT(accept()));
  connect(btn_cancel, SIGNAL(clicked()), SLOT(reject()));


  QWidget *w1  = new QWidget (this);
  w1->setGeometry(10, 20, 250, 15);
  QLabel  *l1  = new QLabel  ("Zmiana wspczynnika FPS napisw z:", w1);
  l1->setAutoResize(true);

  editsrc = new QLineEdit(this);
  editsrc->setValidator( new QDoubleValidator(0.1, 200.0, 5, editsrc) );
  editsrc->setGeometry (20, 50, 160, 20);
  editsrc->setText("25.0");

  QWidget *w2  = new QWidget (this);
  w2->setGeometry(190, 52, 50, 15);
  QLabel  *l2  = new QLabel  ("klatek/s.", w2);
  l2->setAutoResize(true);

  editdest = new QLineEdit(this);
  editdest->setValidator( new QDoubleValidator(0.1, 200.0, 5, editsrc) );
  editdest->setGeometry (20, 50+40, 160, 20);
  editdest->setText("29.0");

  QWidget *w3  = new QWidget (this);
  w3->setGeometry(190, 52+40, 50, 15);
  QLabel  *l3  = new QLabel  ("klatek/s.", w3);
  l3->setAutoResize(true);

  editsrc->setFocus();
};

//////////////////// SLOTY /////////////////
void SubFpschange::accept()
{
  *srcfps   = atof(editsrc->text());
  *destfps  = atof(editdest->text());
  done(true);
}
