#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qhbox.h>
#include <qvbox.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qvalidator.h>
#include <qgroupbox.h>

#include <stdlib.h>

#include "sub_shift.h"

SubShift::SubShift(double *time, bool *changestart, bool *changeend) : QDialog(NULL, "sub_shift", true)
{
  this->time = time;
  chstart    = changestart;
  chend      = changeend;

  QPushButton *btn_ok, *btn_cancel;
  btn_ok     = new QPushButton("OK", this);
  btn_cancel = new QPushButton("Anuluj", this);
  btn_ok    ->setGeometry(40 +10, 190, 80, 20);
  btn_ok    ->setDefault(true);
  btn_cancel->setGeometry(130+10, 190, 80, 20);
  connect(btn_ok    , SIGNAL(clicked()), SLOT(accept()));
  connect(btn_cancel, SIGNAL(clicked()), SLOT(reject()));

  QWidget *w1  = new QWidget (this);
  w1->setGeometry(10, 20, 230, 15);
  QLabel  *l1  = new QLabel  ("Przesunicie czasu napisw o:", w1);
  l1->setAutoResize(true);

  vbox1 = new QVBox(this);
  vbox1->setGeometry(10, 100, 250, 70);

  grp = new QButtonGroup(1, QGroupBox::Horizontal, "", vbox1);
  grp->setExclusive(false);
  b1 = new QCheckBox("&Zmieniaj klatki pocztkowe", grp);
  b2 = new QCheckBox("&Zmieniaj klatki kocowe", grp);
  b1->setChecked(true);
  b2->setChecked(true);

  edit = new QLineEdit(this);
  edit->setValidator( new QDoubleValidator(-99999999.0, 99999999.0, 5, edit) );
  edit->setGeometry (20, 50, 160, 20);
  edit->setText("0");

  QWidget *w2  = new QWidget (this);
  w2->setGeometry(190, 52, 50, 15);
  QLabel  *l2  = new QLabel  ("sekund", w2);
  l2->setAutoResize(true);

  edit->setFocus();
};

//////////////////// SLOTY /////////////////
void SubShift::accept()
{
  *chstart = b1->isChecked();
  *chend   = b2->isChecked();
  *time    = atof(edit->text());
  done(true);
}
