#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qhbox.h>
#include <qvbox.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qvalidator.h>
#include <qgroupbox.h>

#include <stdlib.h>

#include "sub_showtime.h"

SubShowtime::SubShowtime(double *time, bool *enterempty, bool *changeonlyempty, bool *dependonlen, bool *blockshowtime) : QDialog(NULL, "sub_showtime", true)
{
  this->time            = time;
  this->enterempty      = enterempty;
  this->changeonlyempty = changeonlyempty;
  this->dependonlen     = dependonlen;
  this->blockshowtime   = blockshowtime;

  QPushButton *btn_ok, *btn_cancel;
  btn_ok     = new QPushButton("OK", this);
  btn_cancel = new QPushButton("Anuluj", this);
  btn_ok    ->setGeometry(40 +55, 230, 80, 20);
  btn_ok    ->setDefault(true);
  btn_cancel->setGeometry(130+55, 230, 80, 20);
  connect(btn_ok    , SIGNAL(clicked()), SLOT(accept()));
  connect(btn_cancel, SIGNAL(clicked()), SLOT(reject()));


  QWidget *w1  = new QWidget (this);
  w1->setGeometry(10, 20, 230, 15);
  QLabel  *l1  = new QLabel  ("Czas wywietlania napisu:", w1);
  l1->setAutoResize(true);


  vbox1 = new QVBox(this);
  vbox1->setGeometry(10, 90, 340, 120);

  grp = new QButtonGroup(1, QGroupBox::Horizontal, "", vbox1);
  grp->setExclusive(false);
  b1 = new QCheckBox("&Wpisz puste pozycje", grp);
  b2 = new QCheckBox("&Zmieniaj tylko puste czasy", grp);
  b3 = new QCheckBox("&Czas wywietlania zaleny od dugoci napisu", grp);
  b4 = new QCheckBox("&Blokuj czas pokazywania napisu", grp);
  b1->setChecked(false);
  b2->setChecked(false);
  b3->setChecked(true);
  b4->setChecked(true);
  connect(b1, SIGNAL(clicked()), SLOT(setEmpty()));

  edit = new QLineEdit(this);
  edit->setValidator( new QDoubleValidator(0.1, 100.0, 5, edit) );
  edit->setGeometry (20+40, 50, 160, 20);
  edit->setText("3.0");

  QWidget *w2  = new QWidget (this);
  w2->setGeometry(190+40, 52, 50, 15);
  QLabel  *l2  = new QLabel  ("sekund", w2);
  l2->setAutoResize(true);

  edit->setFocus();
};

//////////////////// SLOTY /////////////////
void SubShowtime::accept()
{
  *this->enterempty      = b1->isChecked();
  *this->changeonlyempty = b2->isChecked();
  *this->dependonlen     = b3->isChecked();
  *this->blockshowtime   = b4->isChecked();
  *time    = atof(edit->text());
  done(true);
}

void SubShowtime::setEmpty()
{
  b2->setEnabled( !b1->isChecked() );
  b3->setEnabled( !b1->isChecked() );
  b4->setEnabled( !b1->isChecked() );
}
